#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire500six4xi.py">
#<abstract4xi abstract = "fires to direction six and to distance 500"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2six4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2SIX - COORDINATE SIGNS OF SHOOT2SIX4XI: (X - ,Y + ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2six5004xi



# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

shot2six5004xi = {
                1:'-100x62y-485z',
                2:'-100x69y-484z',
                3:'-100x78y-483z',
                4:'-100x86y-482z',
                5:'-101x467y-144z',
                6:'-108x468y-136z',
                7:'-112x324y-363z',
                8:'-125x460y-149z',
                9:'-127x315y-366z',
                10:'-132x461y-140z',
                11:'-142x304y-369z',
                12:'-149x451y-153z',
                13:'-14x202y-456z',
                14:'-155x452y-145z',
                15:'-156x293y-373z',
                16:'-169x281y-376z',
                17:'-172x441y-158z',
                18:'-178x442y-150z',
                19:'-182x269y-379z',
                20:'-193x256y-383z',
                21:'-194x430y-163z',
                22:'-201x430y-155z',
                23:'-204x242y-386z',
                24:'-214x229y-389z',
                25:'-215x418y-168z',
                26:'-222x418y-159z',
                27:'-223x214y-392z',
                28:'-231x200y-395z',
                29:'-236x405y-172z',
                30:'-238x185y-398z',
                31:'-243x404y-164z',
                32:'-244x170y-401z',
                33:'-249x155y-404z',
                34:'-24x196y-458z',
                35:'-251x8y-431z',
                36:'-253x140y-407z',
                37:'-255x21y-429z',
                38:'-256x124y-410z',
                39:'-256x390y-177z',
                40:'-257x35y-426z',
                41:'-259x109y-413z',
                42:'-259x50y-424z',
                43:'-260x94y-416z',
                44:'-261x64y-421z',
                45:'-261x79y-418z',
                46:'-263x389y-169z',
                47:'-275x375y-182z',
                48:'-282x374y-174z',
                49:'-293x358y-186z',
                50:'-300x357y-178z',
                51:'-310x341y-191z',
                52:'-315x387y-1z',
                53:'-317x340y-183z',
                54:'-326x323y-195z',
                55:'-333x321y-188z',
                56:'-335x370y-6z',
                57:'-341x304y-200z',
                58:'-348x302y-192z',
                59:'-34x190y-460z',
                60:'-354x352y-11z',
                61:'-355x285y-205z',
                62:'-362x282y-197z',
                63:'-368x264y-209z',
                64:'-372x333y-16z',
                65:'-374x262y-201z',
                66:'-380x244y-214z',
                67:'-386x241y-206z',
                68:'-388x313y-21z',
                69:'-390x222y-218z',
                70:'-396x219y-210z',
                71:'-399x201y-223z',
                72:'-404x292y-26z',
                73:'-407x178y-227z',
                74:'-414x156y-232z',
                75:'-419x133y-236z',
                76:'-419x270y-31z',
                77:'-423x111y-240z',
                78:'-426x88y-245z',
                79:'-427x20y-258z',
                80:'-428x42y-253z',
                81:'-428x65y-249z',
                82:'-432x248y-36z',
                83:'-43x184y-462z',
                84:'-444x225y-41z',
                85:'-44x355y-349z',
                86:'-455x201y-46z',
                87:'-464x177y-51z',
                88:'-472x152y-56z',
                89:'-479x127y-61z',
                90:'-484x101y-66z',
                91:'-486x237y-258z',
                92:'-488x76y-71z',
                93:'-491x50y-76z',
                94:'-492x24y-81z',
                95:'-51x177y-464z',
                96:'-52x478y-134z',
                97:'-59x169y-466z',
                98:'-62x348y-352z',
                99:'-66x162y-468z',
                100:'-68x2y-495z',
                101:'-72x154y-470z',
                102:'-73x6y-494z',
                103:'-77x10y-493z',
                104:'-77x473y-139z',
                105:'-78x146y-471z',
                106:'-79x341y-356z',
                107:'-82x15y-492z',
                108:'-83x137y-473z',
                109:'-84x475y-131z',
                110:'-85x21y-492z',
                111:'-87x129y-474z',
                112:'-89x26y-491z',
                113:'-91x120y-476z',
                114:'-92x33y-490z',
                115:'-94x112y-477z',
                116:'-95x39y-489z',
                117:'-96x333y-359z',
                118:'-97x103y-479z',
                119:'-97x47y-488z',
                120:'-99x54y-487z',
                121:'-99x94y-480z'}

#"
#/>


# -------------------------------------------------------------------------------------------------------------------
#<function4xi function = "fire500six4xi" usage = "target function for charge2six4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------------------------
def fire500six4xi(queue2six, consumer_channel2six, publisher_channel2six):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE500SIX4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE500SIX4XI -  QUEUE2SIX: ", queue2six)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE500SIX4XI -  CONSUMER_CHANNEL2SIX: ", consumer_channel2six)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE500SIX4XI -  PUBLISHER_CHANNEL2SIX: ", publisher_channel2six)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE500SIX4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2SIX: ", queue2six, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2six.put(shot2six5004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE500SIX4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2SIX: ", queue2six, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE500SIX4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2SIX: ", queue2six, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE500SIX4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2SIX: ", publisher_channel2six, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2six8shot2six500x4xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2six8shot2six500x4xi</nack2put4xi>" 
            
        publisher_channel2six.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE500SIX4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SIX: ", publisher_channel2six, " - TIME: ", time4xi()) 
            # 
        
    except:
        print(" (STEP 3C/33) OF FIRE500SIX4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SIX: ", publisher_channel2six, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE500SIX4XI - RETURNING QUEUE OBJECT QUEUE2SIX: ", queue2six, " - TIME: ", time4xi())  
        # 
            
    return queue2six    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire500six4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
